<?php
/* =====================================
  template.php
* ------------------------------------- */

/**
 * Implements theme_menu_item_link()
 * yup original is from zen and we humbly say thanx :)
 */
function moshpit_menu_item_link($link) {
  if (empty($link['localized_options'])) {
    $link['localized_options'] = array();
  }

  //define a class for each tab 
  //TODO check out the multilang hell....
  $linkclass = mothership_id_safe($link['title']);
  
  // If an item is a LOCAL TASK, render it as a tab
  if($link['type'] & MENU_IS_LOCAL_TASK) {
    $link['title'] = '<span class="tab '. $linkclass .' ">' . check_plain($link['title']) . '</span>';
    $link['localized_options']['html'] = TRUE;
    $link['localized_options']['attributes'] = array('class' => $linkclass);
  }else{
    // its a standard menu item lets kick in a span class
    $link['title'] = '<span class="icon-'. $linkclass .' ">' . check_plain($link['title']) . '</span>';
    $link['localized_options']['html'] = TRUE;
    $link['localized_options']['attributes'] = array('class' => $linkclass);
  }
  
  return l($link['title'], $link['href'], $link['localized_options']);
}

/*adding a top level to the nice menu*/
function moshpit_nice_menu_build($menu, $level = "0") {
  $output = '';
  /*new class*/
  $level_class = "nice-menu-level-".$level.' ';

  foreach ($menu as $menu_item) {
    $mlid = $menu_item['link']['mlid'];
    // Check to see if it is a visible menu item.

    if ($menu_item['link']['hidden'] == 0) {
      // Build class name based on menu path
      // e.g. to give each menu item individual style.
      // Strip funny symbols.
      $clean_path = str_replace(array('http://', '<', '>', '&', '=', '?', ':'), '', $menu_item['link']['href']);
      // Convert slashes to dashes.
      $clean_path = str_replace('/', '-', $clean_path);
      $path_class = 'menu-path-'. $clean_path;

      // If it has children build a nice little tree under it.
      if ((!empty($menu_item['link']['has_children'])) && (!empty($menu_item['below']))) {
        // Keep passing children into the function 'til we get them all.
        $children = theme('nice_menu_build', $menu_item['below'],'1');
        // Set the class to parent only of children are displayed.
        $parent_class = $children ? 'menuparent ' : '';
        $output .= '<li id="menu-'. $mlid .'" class=" '.$level_class . $parent_class . $path_class .'">'. theme('menu_item_link', $menu_item['link']);
        // Build the child UL only if children are displayed for the user.
        if ($children) {
          $output .= '<ul class="' . $level_class . '">';
          $output .= $children;
          $output .= "</ul>\n";
        }
        $output .= "</li>\n";
      }
      else {
        $output .= '<li id="menu-'. $mlid .'" class="'. $level_class . $path_class .'">'. theme('menu_item_link', $menu_item['link']) .'</li>'."\n";
      }
			
    }

  }
  return $output;
}



function moshpit_links($links, $attributes = array('class' => 'moshpit links')) {
//  die('mothership_links');

  global $language;
  $output = '';

  if (count($links) > 0) {
    $output = 'moshpit: <ul'. drupal_attributes($attributes) .'>';

    $num_links = count($links);
    $i = 1;

    foreach ($links as $key => $link) {
      $class = $key;

      // Add first, last and active classes to the list of links to help out themers.
      if ($i == 1) {
        $class .= ' first';
      }
      if ($i == $num_links) {
        $class .= ' last';
      }
      if (isset($link['href']) && ($link['href'] == $_GET['q'] || ($link['href'] == '<front>' && drupal_is_front_page()))
          && (empty($link['language']) || $link['language']->language == $language->language)) {
        $class .= ' active';
      }
      $output .= '<li'. drupal_attributes(array('class' => $class)) .'>';

      if (isset($link['href'])) {
        // Pass in $link as $options, they share the same keys.
        $output .= l($link['title'], $link['href'], $link);
      }
      else if (!empty($link['title'])) {
        // Some links are actually not links, but we wrap these in <span> for adding title and class attributes
        if (empty($link['html'])) {
          $link['title'] = check_plain($link['title']);
        }
        $span_attributes = '';
        if (isset($link['attributes'])) {
          $span_attributes = drupal_attributes($link['attributes']);
        }
        $output .= '<span'. $span_attributes .'>'. $link['title'] .'</span>';
      }

      $i++;
      $output .= "</li>\n";
    }

    $output .= '</ul>';
  }

  return $output;
}

